-- package constants
greeting = "Imez's Wheel Plugin";
idString = "Wheel: ";
dataString = "WheelData";
quickSlotSize = 36;
dragHeight = 10;

-- colors
white = Turbine.UI.Color(1, 1, 1, 1);
invisible = Turbine.UI.Color(0, 0, 0, 0);

-- package variables
verbose = false;

-- package functions
function output(message)
  Turbine.Shell.WriteLine(idString .. message);
end

function verboseOutput(message)
  if (verbose) then
    output(message);
  end
end

function outputVariable(table)
  if (not table) then
    output("Nil");
  elseif (type(table) ~= "table") then
    output("Non-Table|" .. table .. "|");
  else
    for k,v in pairs(table) do
      output("Key=" .. k);
      outputVariable(v);
    end
  end
end

-- shortcut management
function convertToShortcut(table)
  return Turbine.UI.Lotro.Shortcut(table.Type, table.Data);
end

function convertFromShortcut(shortcut)
  local result = {};
  result.Type = shortcut:GetType();
  result.Data = shortcut:GetData();
  return result;
end

-- data management
function saveData()
  Turbine.PluginData.Save(Turbine.DataScope.Character, dataString, data);
end

function loadData()
  data = Turbine.PluginData.Load(Turbine.DataScope.Character, dataString);
  if (type(data) ~= "table") then
    data = {};
  end
end

--[[
Turbine.Engine.GetGameTime();
--]]
