WheelOptionsWindow = class(Turbine.UI.Lotro.Window);

function WheelOptionsWindow:Constructor()
  Turbine.UI.Lotro.Window.Constructor(self);
  self:getData();
  self:SetText("Wheel");
  self:SetSize(100, 175);
  self:SetPosition(data.options.x, data.options.y);
  self:SetOpacity(1);
  self:SetVisible(false);

  self.MouseLeave = function(sender, args)
    if (
      (data.options.x ~= self:GetLeft()) or
      (data.options.y ~= self:GetTop())
    ) then
      data.options.x = self:GetLeft();
      data.options.y = self:GetTop();
      saveData();
      self:output("Saving Changes");
    end
  end

  self.newButton = Turbine.UI.Lotro.Button();
  self.newButton:SetParent(self);
  self.newButton:SetPosition(25, 50);
  self.newButton:SetSize(100, 25);
  self.newButton:SetText("New Wheel");
  self.newButton.Click = function(sender, args)
    addWheel();
    self:updateList();
    self:output("New Wheel");
  end

  self.removeButton = Turbine.UI.Lotro.Button();
  self.removeButton:SetParent(self);
  self.removeButton:SetPosition(25, 125);
  self.removeButton:SetSize(100, 25);
  self.removeButton:SetText("Remove");
  self.removeButton.Click = function(sender, args)
    if (wheels[self.list[self.selected]]) then
      self:output("Remove Wheel " .. wheels[self.list[self.selected]].id);
      removeWheel(self.list[self.selected]);
      self:updateList();
    end
  end

  self.label = Turbine.UI.Label();
  self.label:SetParent(self);
  self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label:SetText("Sup");
  self.label:SetSize(100, 25);
  self.label:SetPosition(25,100);

  self.label.MouseWheel = function(sender, args)
    self.selected = self.selected - args.Direction;
    if (self.selected > table.getn(self.list)) then
      self.selected = 1;
    end
    if (self.selected < 1) then
      self.selected = table.getn(self.list);
    end
    if (self.selected < 1) then
      self.selected = 1;
    end
    self:redrawList();
  end

  self:output("Window Created");
  self:updateList();
end

function WheelOptionsWindow:output(message)
  verboseOutput("Options - " .. message);
end

function WheelOptionsWindow:getData()
  local padding = 50;
  if (type(data.options) ~= "table") then
    data.options = {};
  end
  if (not data.options.x) then
    data.options.x = padding;
  end
  if (not data.options.y) then
    data.options.y = padding;
  end
end

function WheelOptionsWindow:redrawList()
  if (wheels[self.list[self.selected]]) then
    self.label:SetText("Wheel " .. wheels[self.list[self.selected]].id);
    self.label:SetVisible(true);
    self.removeButton:SetVisible(true);
    self:output("Wheel|" .. wheels[self.list[self.selected]].id .. "|");
  else
    self.label:SetText("No Wheel");
    self.label:SetVisible(false);
    self.removeButton:SetVisible(false);
    self:SetVisible(true);
  end
end

function WheelOptionsWindow:updateList()
  self.list = {};
  local i = 0;
  for k,v in pairs(wheels) do
    if (v) then
      i = i + 1;
      self.list[i] = k;
    end
  end
  self.selected = 1;
  self:redrawList();
end
